// Desktop Scroller.
// Copyright (C) 2011-2012 Marcos Diaz <diazmencia@gmail.com>.
//
// Desktop Scroller is libre software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation, either version 3 of the License, or newer.
//
// You should have received a copy of the GNU General Public License along with
// this file. If not, see <http://www.gnu.org/licenses/>.

const St = imports.gi.St
const Main = imports.ui.main

// Main class for the extension.
function main(){
	this.enable = function(){
		var monitor = Main.layoutManager.primaryMonitor
		var x = monitor.width - 1
		var y = 30
		var width = 1
		var height = monitor.height - 60
		this.actor = new St.Button({style_class:'desktopscroller'})
		this.actor.set_position(x,y)
		this.actor.set_width(width)
		this.actor.set_height(height)
		this.actor.opacity = 0
		this.actor.connect('scroll-event', this.hook.bind(this))
		Main.layoutManager.addChrome(this.actor)
		this.overview = get_actor_by_name(global.overlay_group, 'overview')
		this.signaladdr0 = this.overview.connect('show', this.hide.bind(this))
		this.signaladdr1 = this.overview.connect('hide', this.show.bind(this))
	}
	this.disable = function(){
		Main.layoutManager.removeChrome(this.actor)
		this.actor.destroy()
		this.overview.disconnect(this.signaladdr0)
		this.overview.disconnect(this.signaladdr1)
	}
	this.hook = function(actor, event){
		var direction = event.get_scroll_direction()
		if(direction==0) this.switch_workspace(-1)
		if(direction==1) this.switch_workspace(1)
	}
	this.switch_workspace = function(incremental){
		var index = global.screen.get_active_workspace_index()
		index += incremental
		global.screen.get_workspace_by_index(index).activate(true)
	}
	this.show = function(){
		this.actor.show()
	}
	this.hide = function(){
		this.actor.hide()
	}
}

// Gnome-shell extension API.
function init() {desktopscroller = new main()}
function enable() {desktopscroller.enable()}
function disable() {desktopscroller.disable()}

// Other utils.
function get_actor_by_name(actor, name){
	var children = actor.get_children()
	for(var i in children) if(children[i].name == name) return children[i]
}
